package goap

type W3VcardAddressData struct {
	FullValueType[string]
}

func (misskeysummarydata *W3VcardAddressData) GetSelfOrBase() (BaseApChain, bool) {
	return misskeysummarydata.Next, true
}

func (misskeysummarydata *W3VcardAddressData) MarshalToMap() map[string]any {
	return misskeysummarydata.MarshalToMapWithName(KEY_W3_VCARD_ADDRESS)
}

func ParseW3VcardAddressData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[string](raw, next, KEY_W3_VCARD_ADDRESS)
	if err != nil {
		return nil, err
	}
	return &W3VcardAddressData{*tmp}, nil
}

func AppendW3VcardAddressData(base BaseApChain, value ValueValue[string]) BaseApChain {
	return &W3VcardAddressData{FullValueType[string]{base, value}}
}

type W3VcardBirthdayData struct {
	FullValueType[string]
}

func (misskeysummarydata *W3VcardBirthdayData) GetSelfOrBase() (BaseApChain, bool) {
	return misskeysummarydata.Next, true
}

func (misskeysummarydata *W3VcardBirthdayData) MarshalToMap() map[string]any {
	return misskeysummarydata.MarshalToMapWithName(KEY_W3_VCARD_BIRTHDAY)
}

func ParseW3VcardBirthdayData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[string](raw, next, KEY_W3_VCARD_BIRTHDAY)
	if err != nil {
		return nil, err
	}
	return &W3VcardBirthdayData{*tmp}, nil
}

func AppendW3VcardBirthdayData(base BaseApChain, value ValueValue[string]) BaseApChain {
	return &W3VcardBirthdayData{FullValueType[string]{base, value}}
}
